#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include <GL/gl.h>	
#include <GL/glu.h>	
#include <stdlib.h>
#include <SDL.h>

void DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT);
  SDL_GL_SwapBuffers();
}

void myGLReshapeFunc(GLsizei w, GLsizei h)
{
	glMatrixMode (GL_PROJECTION);   
	glLoadIdentity ();
	float ratio=(float)w/(float)h;
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_MODELVIEW);
}


int main(int argc, char **argv) 
{  
  /* Initialize SDL for video output */
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    fprintf(stderr, "Unable to initialize SDL: %s\n", SDL_GetError());
    exit(1);
  }

  /* Create a 640x480 OpenGL screen */
  if ( SDL_SetVideoMode(640, 480, 0, SDL_OPENGL |SDL_RESIZABLE) == NULL ) {
    fprintf(stderr, "Unable to create OpenGL screen: %s\n", SDL_GetError());
    SDL_Quit();
    exit(2);
  }

	/* Loop, drawing and checking events */
	int done = 0;
  myGLReshapeFunc(640,480); 
	while ( ! done ) 
	{
    SDL_Event event;
	  SDL_WaitEvent(&event);
		
		switch(event.type)
		{  
					case SDL_VIDEOEXPOSE     : 	DrawGLScene(); break;  
					case SDL_QUIT    : done = 1;  
						                 break ;
					case SDL_KEYDOWN : if ( event.key.keysym.sym == SDLK_ESCAPE ) 
														           done = 1;
												     break;
			    case SDL_VIDEORESIZE	: SDL_SetVideoMode(event.resize.w,event.resize.h, 0, SDL_OPENGL |SDL_RESIZABLE);
															    myGLReshapeFunc(event.resize.w,event.resize.h); 
															    break;
    }    
  }
  SDL_Quit();
  return 1;
}
